-- main.lua for messageBox.love
message = require "message"

function love.load()
    color = {
        white	= {255,255,255,255},
        black	= {  0,  0,  0,255},
        gray	= {128,128,128,255},
        window 	= {  0, 80,160,255},
        shadow	= { 96, 96, 96,255},
		red		= { 85,  0,  0,255},
		green	= {  0, 85,  0,255},
		yellow	= { 55, 55,  0,255},
		vred	= {255,  0,  0,255},
		blue	= { 50, 50,255,255}
		}
	message.advanceKey='z'
	s	 = {}
	s[1] = '|f20Welcome to the Magnificant|nworld of litearc text box library!'
	s[2] = '|f14With this library, you can create |na variety of text box displays.|n    Press <z> to continue.'
	s[3] = 'Features include: |n   in line text color change|n   text shadows|n   controled typewriter speed|n   midline pauses |n   controlled line breaks |n   background color selection|n   text box width|n   textbox height|n   fontsize (on per box basis)'
	s[4] = 'The text boxes can:|n   automatically time out|n   require key press to continue|n   prevent keypress overides'
	s[5] = 'The library assumes standard LOVE format:|n   function love.load()|n   function love.draw()|n   function love.update(dt)|n   function love.keypressed(k)'
	s[6] = 'To add text boxes to an existing script:|n   in the folder with your main.lua add:|n      |cafafffffmessage.lua|n  |cffffffffat top of script add:|n      |cafafffffmessage = require \'message\'|cffffffff|n   in love.load add:|n      |cafafffffformated text string|n      message.load()|n      message.prepare(string)|n   |cffffffffin love.draw add:|n      |cafafffffmessage.draw()|n|cffffffffThat is all there is to it!|n|cffff00ffA cfg file will change default settings.'
	s[7] = 'Some |f15messages can be skipped by pressing |c88ccffffz|cffffffff, BUT your mother told you to take out the GARBAGE, so you can\'t skip this one!'
    s[8] = 'The code in |c2f2f2fffmessage.lua|cffffffff is definitely NOT optimized and even though I add some comments, it is still hard to follow.  I\'m sure that \'litearc\' will continue to improve it.'
	s[9] = 'Press ( |cff6666ffescape|cffffffff ) to exit'
	cfg = {
		wincol 	= {color.window,color.gray,color.green,color.yellow,color.yellow,color.red,color.vred,color.window},
		msgspd	= {  30, 100,  30, 999,  30,  15,   30,  30,  30},
		textsh 	= {true,true,true,true,true,true,true,true,true},
		x		= { 235, 300, 500, 100, 100, 200, 300, 100, 550},
		y		= { 200, 100, 400, 300, 350, 100, 280, 550,  50},
		w		= { 330, 220, 200, 200, 300, 270, 200, 600, 160},
		h		= { nil,  86,  50,  74,  74, nil,  98,  32, nil},
		wait	= {   2, nil, nil, nil, nil,  nil, nil, nil,  1},
		skip	= {true,true,true,true,true, true,false,true,true},
		}
	num = 1
	set = {}
	for i,j in pairs(cfg) do set[i]=j[num] end
	message.load()
	message.prepare(s[num],set)
	cx, cy, cr, seg	= 400, 300, 200, 8
	pi	= math.pi
	ca1, ca2	= 0.0, 0.1 * pi
	tab={ wait = 0.5, w = 160 }
	txt="|cffff00fflitearc is |f20great!"
	end

function love.update(dt)
	if message.completed then
		--num = num < #s and num + 1 or 1
		if num<#s then
			num = num + 1
			set = {}
			for i,j in pairs(cfg) do set[i] = j[num] end
			message.prepare(s[num],set)
			else
				tab.x = math.random(50,600)
				tab.y = math.random(50,500)
				set=tab
				message.prepare(txt,set)
			end
		end
	ca1, ca2 = ca1 + dt, ca2 + dt
	if ca1 > 2 * pi then ca1 = 0 ca2 = 0.1 * pi end
	end

function love.draw()
	lg.setColor( {255,255,0,255} )
	love.graphics.arc( "line", cx, cy, cr, ca1, ca2, seg )
	message.draw( )
	lg.setColor({255,255,255,255})
	if msg.done then mx="message done" else mx = "message being drawn" end
	lg.print(mx,10,10)
	end

function love.keypressed(k)
	if k == message.advanceKey then message.next = true end
	if k == 'escape' then love.event.push( 'quit' )	end
	end
